package ryulib.game;

import android.view.KeyEvent;
import android.view.MotionEvent;
import ryulib.graphic.Boundary;

public class GameControlBase {
	
	public GameControlBase(GameControlGroup gameControlGroup) {
		super();
		
		_GameControlGroup = gameControlGroup;

		if (_GameControlGroup != null) {
			_GameControlList = gameControlGroup._GroupList;
			_GameControlList.AddQue(this);
		}
	}

	GameControlGroup _GameControlGroup = null;
	
	protected GameControlList _GameControlList = null;
	
	// GameControlList ٷ    , 
	// ÷׸ ϸ GameControlList  ñ⿡ Ѵ. 
	boolean _Deleted = false;

	// MotionEvent.ACTION_DOWN õ  ü  true
	boolean _Focused = false;
	
	private Boundary _Boundary = new Boundary(0, 0, 0, 0);
	private boolean _Visible = true;
	private boolean _Enabled = true;
	private boolean _Started = false;
	
	
	// 浹 ׽Ʈ  .  
	// Ʈ ũ⺸   浹 ؾ  찡   _Boundary  óѴ.
	//     ̹ Ȯ 簢 ƴϱ  ڸ  εġ    ִ.
	// null Ǿ  浹 ׽Ʈ  ʰ Ǹ, 浹 ׽Ʈ ʿ  ü Ҵϸ ȴ. 
	protected HitArea getHitArea() {
		return null;
	}
	
	void onRepeate(GamePlatformInfo platformInfo) {
		if (_Started == false) {
			_Started = true;
			onStart(platformInfo);
		}
		
		if ((_Deleted == false) && _Enabled && _Visible) onTick(platformInfo);
		if ((_Deleted == false) && _Visible) onDraw(platformInfo);
	}
	
	protected void onStart(GamePlatformInfo platformInfo) {
		// Override ؼ 
	}
	
	protected void onTick(GamePlatformInfo platformInfo) {
		// Override ؼ 
	}
	
	protected void onDraw(GamePlatformInfo platformInfo) {
		// Override ؼ 
	}
	
	protected boolean onKeyDown(GamePlatformInfo platformInfo, int keyCode, KeyEvent msg) {
		// Override ؼ 
		return false;
    }

    protected boolean onKeyUp(GamePlatformInfo platformInfo, int keyCode, KeyEvent msg) {
		// Override ؼ 
		return false;
    }

    protected boolean onTouchEvent(GamePlatformInfo platformInfo, MotionEvent event) {
		// Override ؼ 
		return false;
    }
    
	public void BringToFront() {
		_GameControlList.BringToFront(this);
	}
	
	public void SendToBack() {
		_GameControlList.SendToBack(this);
	}
	
	public GameControlGroup getGameControlGroup() {
		return _GameControlGroup;
	}

	public Boundary getBoundary() {
		return _Boundary;
	}

	public void setBoundary(Boundary value) {
		_Boundary = value;
	}
    
    public boolean getVisible() {
    	return _Visible;
    }
    
    public void setVisible(boolean value) {
    	_Visible = value;
    }
    
    public boolean getEnabled() {
    	return _Enabled;
    }
    
    public void setEnabled(boolean value) {
    	_Enabled = value;
    }

	public boolean isStarted() {
		return _Started;
	}

	public boolean getFocused() {
		return _Focused;
	}
	
	public boolean getDeleted() {
		return _Deleted;
	}
	
	public void Delete() {
		setVisible(false);
		setEnabled(false);		
		_Deleted = true;
	}

}
